﻿EnableExplicit

;CompilerIf Defined(lDebugF, #PB_Procedure) = 0
    Procedure lDebugF(st.s, AppendF.b=1)
    Protected fn.s ="c:\debugf.dbg", f.l, RET, lastErr
    
        CompilerIf Defined(DebugFN$, #PB_Constant)
            fn = #DebugFN$
        CompilerEndIf
        
        If AppendF
            ; Debug GetLastError_() = 0
            lastErr = GetLastError_()
            f = OpenFile(#PB_Any, fn)
            ; Debug GetLastError_() = 183 if file exist
            SetLastError_(LastErr)
            FileSeek(f, FileSize(fn))
            
        Else
            f = CreateFile(#PB_Any, fn)
            If st = "" 
                st = "Run: "+FormatDate("%dd/%mm/%yyyy - %hh:%ii:%ss", Date())  
            EndIf
        EndIf
            
        If f 
            WriteStringN(f, st)
            FlushFileBuffers(F)
            CloseFile(f)
            ProcedureReturn 1 ; routine processed
            
        Else
            ProcedureReturn 0 ; routine NOT processed
    
        EndIf
        
    EndProcedure
;CompilerEndIf

#HRT_GET_Ticks  = 0
#HRT_GET_ns     = 1
#HRT_GET_ms     = 2
#HRT_START      = 4
#HRT_RESTART    = 16
#HRT_INIT       = 8

Global Dim dMult.d(2), gdFreq.d
Procedure.q HRTimerWait(ns.q)
Protected qTicks.q, qEndTicks.q, dEndTicks.d
    
    QueryPerformanceCounter_(@qTicks)                        ; first thing get ticks
    dEndTicks = qTicks + ns /1000000000 * gdFreq
    
    qEndTicks = dEndTicks
    
;     Debug "Expr = " +Str(qEndTicks) + " - " +Str(qTicks)
;     Debug ""
    
    ;!LD DWORD[WaitTicks]
    Repeat 
        QueryPerformanceCounter_(@qTicks)
        ; Debug qTicks - qEndTicks
        
    Until (qTicks - qEndTicks) > 0
        
EndProcedure

Procedure.q HRTimer(HRTAction.l=0)
Static dFreq.d, dStartTicks.d, qFreq.q, qStartTicks.q
Protected qTicks.q, dTicks.d, qRet.q, T1.LARGE_INTEGER, dRet.d
;Shared Mult.q()

    QueryPerformanceCounter_(@qTicks)                        ; first thing get ticks
    
    dTicks = qTicks
        
    If Not dFreq 
        QueryPerformanceFrequency_(@qFreq)
        dFreq = qFreq
        gdFreq = dFreq
        
        If Not qFreq                                        ; in Hz
    
            ProcedureReturn 0
            
        Else
           
            dMult(#HRT_GET_Ticks) = 1.0
            dMult(#HRT_GET_ns) = 1000000000.0 / dFreq ; convert ns to ms = / 10^6
            dMult(#HRT_GET_ms) = 1000.0 / dFreq

            dStartTicks = dTicks
            
        EndIf
    EndIf
    
    If HRTAction = #HRT_START
        
        dStartTicks = dTicks
        ProcedureReturn dStartTicks
        
    ElseIf HRTAction & #HRT_RESTART                             ; automatically restart the counter
        
        QueryPerformanceCounter_(@qStartTicks)                       
        HRTAction - #HRT_RESTART
        dRet = (dTicks - dStartTicks) * dMult(HRTAction)

        dStartTicks = qStartTicks
       
    Else
        dRet = (dTicks - dStartTicks) * dMult(HRTAction)
        
    EndIf

    ProcedureReturn dRet;qRet
    
EndProcedure


Procedure DebugC(st.s)
    PrintN(st)
EndProcedure

CompilerIf 0; #PB_Compiler_Debugger
    Define k, qT1.q, qT2.q, dDt1.d, dDt2.d
    Define dT1.d, dT2.d

    OpenConsole()

    HRTimer(#HRT_START)                   ; init timer 
    Sleep_(1000)
    DebugC( Str(HRTimer(#HRT_GET_ns)) +" ns")
    DebugC( Str(HRTimer(#HRT_GET_ms)) +" ms")
    
    qT1 = HRTimer(#HRT_GET_ns)
    qT2 = HRTimer(#HRT_GET_ns)
    dDt1 = (qT2 - qT1)
    DebugC("LT for 2 HRTimer(#HRT_GET_ns) calls")
    DebugC (#TAB$ + StrD(dDt1,2) +" ns")

    QueryPerformanceCounter_(@qT1)
    QueryPerformanceCounter_(@qT2)
    dDt2 = (qT2 - qT1)/gdFreq*1000000000
    DebugC("LT for 2 QueryPerformanceCounter calls")
    debugC(#TAB$ + StrD(qT2 - qT1,2) +" ticks = "+StrD(dDt2,2)+" ns")
    
    DebugC( "Overhead of the HRTimer(#HRT_GET_ns) vs direct API Call")
    DebugC( #TAB$ + StrD(dDt1 - dDt2,2) +" ns")
    
    qT1 = HRTimer(#HRT_GET_Ticks)
    qT2 = HRTimer(#HRT_GET_Ticks)
    dDt1 = (qT2 - qT1)/gdFreq*1000000000
    DebugC( "Overhead of the HRTimer(#HRT_GET_Ticks) vs direct API call")
    DebugC( #TAB$ + StrD(dDt1 - dDt2,2) +" ns")

    DebugC( ""   ) 
    For k = 1 To 1000

        HRTimer(#HRT_GET_ns)
    
    Next k
    
    DebugC( Str(HRTimer(#HRT_GET_ms + #HRT_RESTART)) +" ms for 1000 HRTimer(#HRT_GET_ns) calls")
    
    Sleep_(100): Debugc("SLEEP 100 ms")
    DebugC( Str(HRTimer(#HRT_GET_ms )) +" ms")
    
    DebugC("press enter to run the Precision Test...")

        
    ; Input() ; //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    Define LTns.q, LTms.q, i, qElapsedns.q, qStartns.q
    
    DebugC("")
    DebugC("HiRes Timer Precision Test")
    DebugC("#    ns" + #TAB$ + "   ms "+#TAB$+"Std Timer    "+#TAB$ + "Err%" + #TAB$ + "HiRes Timer "+#TAB$ +" Err% ")
    For i = 3 To 9
        LTns = 1 * Pow(10, i)
        LTms = LTns/1000000
        Print(Str(i) +"  10^"+Str(i) + #TAB$+"   "+Str(LTms))
        
        If LTms >= 1
            HRTimer(#HRT_START): 
            Sleep_(LTms)
            qElapsedns = HRTimer(#HRT_GET_ns):      
            ; Print(Str(StdElapsedns) +" ns" + #TAB$ + StrD(Elapsedns/LTns(i)*100, 2) + #TAB$ + Str(Elapsedns) + #TAB$ )
            Print(#TAB$ + Str(qElapsedns) +" ns" + #TAB$  + StrD(100-qElapsedns /LTns*100, 2) + #TAB$ )
        Else
            Print(#TAB$+"Skipped" + #TAB$ + #TAB$ + " n/a " + #TAB$ )
        EndIf
        
        ; qStartns = ElapsedMilliseconds()
        ; Debug (ElapsedMilliseconds() - qStartns)
        HRTimer(#HRT_START)
        HRTimerWait(LTns)
        qElapsedns = HRTimer(#HRT_GET_ns):      
        Print(Str(qElapsedns) +" ns  " + #TAB$ + StrD(100-qElapsedns/LTns*100, 2))

        DebugC("")
;         DebugC(Str(Elapsedns) +" ns " + #TAB$ + #TAB$ +"Err% = "+StrD(Elapsedns/LTns(i)*100, 2))
;         DebugC("HiRes StopWatch Stopped after "+Str(Elapsedns) +" ns = "+Str(Elapsedns/1000000)+" ms, Err% = "+StrD(Elapsedns/LTns(i)*100, 2))
    Next i

    DebugC ("Press enter to END")
    Input()
    CloseConsole()

CompilerEndIf

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableXP